"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const AutoGrowingTextarea = ({ value, onChange, onPaste, placeholder = '', className = '', minRows = 3, maxRows = 20 }) => {
    const textareaRef = (0, react_1.useRef)(null);
    const [metrics, setMetrics] = (0, react_1.useState)({
        height: 40, // Default initial height
        lineCount: 1,
        lineHeight: 20 // Default line height
    });
    const adjustHeight = () => {
        const textarea = textareaRef.current;
        if (!textarea)
            return;
        // Reset height to calculate scroll height
        textarea.style.height = 'auto';
        // Get the computed line height, fallback to default if not available
        const computedStyle = getComputedStyle(textarea);
        const lineHeight = parseInt(computedStyle.lineHeight) || 20;
        const minHeight = lineHeight * minRows;
        // Calculate the scroll height and new height
        const scrollHeight = textarea.scrollHeight;
        const maxHeight = lineHeight * maxRows;
        const newHeight = Math.min(scrollHeight, maxHeight);
        // Calculate actual line count (including wrapped lines)
        const actualLineCount = Math.ceil(scrollHeight / lineHeight);
        const finalHeight = Math.max(newHeight, minHeight);
        // Set the new height
        textarea.style.height = `${finalHeight}px`;
        setMetrics({
            height: newHeight,
            lineCount: actualLineCount,
            lineHeight
        });
    };
    // Initial calculation when component mounts
    (0, react_1.useEffect)(() => {
        const textarea = textareaRef.current;
        if (textarea) {
            // Ensure we have valid initial measurements
            const computedStyle = getComputedStyle(textarea);
            const lineHeight = parseInt(computedStyle.lineHeight) || 20;
            setMetrics(prev => ({
                ...prev,
                lineHeight,
                height: textarea.scrollHeight,
                lineCount: Math.ceil(textarea.scrollHeight / lineHeight)
            }));
            adjustHeight();
        }
    }, []); // Run once on mount
    // Adjust height when value changes
    (0, react_1.useEffect)(() => {
        adjustHeight();
    }, [value, maxRows]);
    return (react_1.default.createElement("div", { className: "space-y-2 AutoGrowingTextarea" },
        react_1.default.createElement("textarea", { ref: textareaRef, value: value, onChange: (e) => {
                onChange(e);
                adjustHeight();
            }, onPaste: onPaste, placeholder: placeholder, className: `w-full min-h-[2.5rem] resize-none overflow-y-auto p-2 border rounded ${className}` })));
};
exports.default = AutoGrowingTextarea;
//# sourceMappingURL=AutoGrowingTextarea.js.map