"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebugTab = void 0;
const react_1 = __importStar(require("react"));
const vscode_1 = require("../vscode");
const DebugTab = () => {
    const [fileChanges, setFileChanges] = (0, react_1.useState)([]);
    const vscode = (0, vscode_1.getVSCodeAPI)();
    (0, react_1.useEffect)(() => {
        const handleMessage = (event) => {
            const message = event.data;
            if (message.type === 'fileChanges') {
                setFileChanges(message.changes);
            }
        };
        window.addEventListener('message', handleMessage);
        return () => window.removeEventListener('message', handleMessage);
    }, []);
    return (react_1.default.createElement("div", { className: "debug-tab-container" },
        react_1.default.createElement("h2", null, "File Changes Log"),
        react_1.default.createElement("div", { className: "file-changes-list" }, fileChanges.map((change, index) => (react_1.default.createElement("div", { key: index, className: "file-change-item" },
            react_1.default.createElement("div", { className: "file-change-header" },
                react_1.default.createElement("span", { className: `change-type ${change.event}` }, change.event),
                react_1.default.createElement("span", { className: "file-path" }, change.path)),
            change.content && react_1.default.createElement("pre", { className: "file-content" }, change.content)))))));
};
exports.DebugTab = DebugTab;
//# sourceMappingURL=DebugTab.js.map