"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.HaxaCredentialsForm = void 0;
const react_1 = __importStar(require("react"));
const vscode_1 = require("../vscode");
const HaxaCredentialsForm = ({ credentialsManager, onCredentialsSubmit }) => {
    const vscode = (0, vscode_1.getVSCodeAPI)();
    const [credentials, setCredentials] = (0, react_1.useState)(() => {
        const saved = credentialsManager.get();
        return {
            apiKey: saved.apiKey,
            serverUrl: saved.serverUrl
        };
    });
    const handleInputChange = (0, react_1.useCallback)((field, value) => {
        setCredentials(prev => ({ ...prev, [field]: value }));
    }, []);
    const handleSubmit = (e) => {
        e.preventDefault();
        credentialsManager.save(credentials);
        vscode.postMessage({
            type: 'credentialsUpdated',
            credentials
        });
        onCredentialsSubmit?.(credentials);
    };
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("button", { onClick: () => vscode.postMessage({ type: 'authenticate' }), type: "button" }, "Sign in with Haxa.AI"),
        react_1.default.createElement("form", { onSubmit: handleSubmit, style: { width: '100%' } },
            react_1.default.createElement("section", { className: "credentials-section haxa-credentials" },
                react_1.default.createElement("h3", null, "Haxa.AI Credentials"),
                react_1.default.createElement("div", { className: "form-group" },
                    react_1.default.createElement("label", { htmlFor: "apiKey" },
                        "API Token [",
                        react_1.default.createElement("a", { href: "https://haxa.ai/profile", target: "_blank", rel: "noopener noreferrer", className: "token-hint" }, "Get it here"),
                        "]"),
                    react_1.default.createElement("input", { type: "password", id: "apiKey", value: credentials.apiKey || '', onChange: e => handleInputChange('apiKey', e.target.value), required: true })),
                react_1.default.createElement("button", { type: "submit" }, "Save")))));
};
exports.HaxaCredentialsForm = HaxaCredentialsForm;
//# sourceMappingURL=HaxaCredentialsForm.js.map