"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Settings = void 0;
const react_1 = __importDefault(require("react"));
const vscode_1 = require("../vscode");
const CredentialsManager_1 = require("../utils/CredentialsManager");
const HaxaCredentialsForm_1 = require("./HaxaCredentialsForm");
const AtlassianCredentialsForm_1 = require("./AtlassianCredentialsForm");
const CredentialsProvider_1 = require("../providers/CredentialsProvider");
const Settings = () => {
    const vscode = (0, vscode_1.getVSCodeAPI)();
    const credentialsManager = react_1.default.useMemo(() => new CredentialsManager_1.CredentialsManager(vscode, window.workspaceId || ''), [vscode]);
    const { credentials, updateCredentials, isLoading } = (0, CredentialsProvider_1.useCredentials)();
    return (react_1.default.createElement("div", { className: "settings-container" },
        react_1.default.createElement("div", { className: "credentials-section" },
            react_1.default.createElement(HaxaCredentialsForm_1.HaxaCredentialsForm, { credentialsManager: credentialsManager }),
            react_1.default.createElement(AtlassianCredentialsForm_1.AtlassianCredentialsForm, { credentialsManager: credentialsManager })),
        react_1.default.createElement("div", { className: 'text-center' },
            react_1.default.createElement("a", { href: "https://haxa.ai/security-compliance", target: '_blank' }, "\u2139\uFE0F Your data at Haxa.AI is safe and secure."))));
};
exports.Settings = Settings;
//# sourceMappingURL=Settings.js.map