"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.CredentialsProvider = exports.useCredentials = void 0;
const react_1 = __importStar(require("react"));
const vscode_1 = require("../vscode");
const CredentialsContext = (0, react_1.createContext)({
    credentials: {},
    updateCredentials: () => { },
    isLoading: true
});
const useCredentials = () => {
    const context = (0, react_1.useContext)(CredentialsContext);
    if (!context) {
        throw new Error('useCredentials must be used within a CredentialsProvider');
    }
    return context;
};
exports.useCredentials = useCredentials;
const CredentialsProvider = ({ children, credentialsManager }) => {
    const [credentials, setCredentials] = (0, react_1.useState)({});
    const [isLoading, setIsLoading] = (0, react_1.useState)(true);
    const vscode = (0, vscode_1.getVSCodeAPI)();
    (0, react_1.useEffect)(() => {
        setCredentials(credentialsManager.get());
        const messageHandler = (event) => {
            const message = event.data;
            if (message.type === 'credentials') {
                setCredentials(prevCreds => ({
                    ...prevCreds,
                    ...message.credentials
                }));
            }
        };
        window.addEventListener('message', messageHandler);
        return () => window.removeEventListener('message', messageHandler);
        setIsLoading(false);
    }, [credentialsManager]);
    const updateCredentials = (newCredentials) => {
        credentialsManager.save(newCredentials);
        setCredentials(prev => ({ ...prev, ...newCredentials }));
    };
    return (react_1.default.createElement(CredentialsContext.Provider, { value: { credentials, updateCredentials, isLoading } }, children));
};
exports.CredentialsProvider = CredentialsProvider;
//# sourceMappingURL=CredentialsProvider.js.map