"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.StateProvider = exports.useAppState = void 0;
const react_1 = __importStar(require("react"));
const vscode_1 = require("../vscode");
const StateContext = (0, react_1.createContext)({
    state: {},
    updateState: () => { },
    isLoading: true
});
const useAppState = () => {
    const context = (0, react_1.useContext)(StateContext);
    if (!context) {
        throw new Error('useAppState must be used within a StateProvider');
    }
    return context;
};
exports.useAppState = useAppState;
const StateProvider = ({ children }) => {
    const vscode = (0, vscode_1.getVSCodeAPI)();
    const [state, setState] = (0, react_1.useState)(() => {
        const savedState = vscode.getState()?.appState || {};
        return savedState;
    });
    const [isLoading, setIsLoading] = (0, react_1.useState)(true);
    (0, react_1.useEffect)(() => {
        const messageHandler = (event) => {
            const message = event.data;
            if (message.type === 'restoreState' && message.state) {
                setState(prevState => ({
                    ...prevState,
                    ...message.state
                }));
            }
        };
        window.addEventListener('message', messageHandler);
        setIsLoading(false);
        return () => window.removeEventListener('message', messageHandler);
    }, []);
    const updateState = (newState) => {
        setState(prevState => {
            const updatedState = { ...prevState, ...newState };
            vscode.setState({ appState: updatedState });
            return updatedState;
        });
    };
    return (react_1.default.createElement(StateContext.Provider, { value: { state, updateState, isLoading } }, children));
};
exports.StateProvider = StateProvider;
//# sourceMappingURL=StateProvider.js.map