"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CredentialsManager = void 0;
class CredentialsManager {
    static STORAGE_KEY = 'haxa-credentials';
    vscode;
    workspaceId;
    constructor(vscode, workspaceId) {
        this.vscode = vscode;
        this.workspaceId = workspaceId;
    }
    getStorageKey() {
        return `${CredentialsManager.STORAGE_KEY}-${this.workspaceId}`;
    }
    save(credentials) {
        const state = this.vscode.getState() || {};
        const storageKey = this.getStorageKey();
        const existingCredentials = state[storageKey] || {};
        state[storageKey] = {
            ...existingCredentials,
            ...credentials
        };
        this.vscode.setState(state);
    }
    get() {
        const state = this.vscode.getState() || {};
        return state[this.getStorageKey()] || {};
    }
    clear() {
        const state = this.vscode.getState() || {};
        delete state[this.getStorageKey()];
        this.vscode.setState(state);
    }
}
exports.CredentialsManager = CredentialsManager;
//# sourceMappingURL=CredentialsManager.js.map